# 将两个有序链表合并为一个新的有序链表并返回。
# 新链表是通过拼接给定的两个链表的所有节点组成的。
# 示例：输入：1->2->4, 1->3->4输出：1->1->2->3->4->4

# Definition for singly-linked list.
#  class ListNode(object):
#     def __init__(self, x):
#         self.val = x
#         self.next = None

class Solution:

    # 递归法
    def mergeTwoLists(self, l1, l2):
        """
        :type l1: ListNode
        :type l2: ListNode
        :rtype: ListNode
        """
        if l1 == None and l2 == None:
            return None
        if l1==None:
            return l2
        if l2==None:
            return l1
        if l1.val<=l2.val:
            l1.next=self.mergeTwoLists(l1.next,l2)
            return l1
        else:
            l2.next=self.mergeTwoLists(l1,l2.next)
            return l2




    # def mergeTwoLists2(self, l1, l2):
    #     """
    #     :type l1: ListNode
    #     :type l2: ListNode
    #     :rtype: ListNode
    #     """
    #     head = ListNode(0)
    #     first = head
    #     while l1 != None and l2 != None:
    #         if l1.val <= l2.val:
    #             head.next = l1
    #             l1 = l1.next
    #         else:
    #             head.next = l2
    #             l2 = l2.next
    #         head = head.next
    #     if l1 != None:
    #         head.next = l1
    #     elif l2 != None:
    #         head.next = l2
    #     return first.next
